
// DotsAndDollars.kt  (c) Kari Laitinen

//  http://www.naturalprogramming.com

//  2023-01-12  File created.

class ThreadToPrintDots : Thread()
{
   var must_print_dots  =  true

   fun stop_this_thread()
   {
      must_print_dots  =  false
   }

   override fun run()
   {
      while ( must_print_dots  ==  true )
      {
         try
         {
            Thread.sleep( 1000 ) // Wait one second.
         }
         catch ( caught_exception : InterruptedException )
         {
         }
      
         print( " ." )
      }
   }
}

class ThreadToPrintDollarSigns : Thread()
{
   var must_print_dollar_signs  =  true

   fun stop_this_thread()
   {
      must_print_dollar_signs  =  false
   }

   override fun run()
   {
      while ( must_print_dollar_signs  ==  true )
      {
         try
         {
            Thread.sleep( 4050 ) // Wait 4.05 seconds.
         }
         catch ( caught_exception : InterruptedException )
         {
         }
      
         print( " $" )
      }
   }
}

fun main()
{
   val thread_to_print_dots = ThreadToPrintDots()
   val thread_to_print_dollar_signs = ThreadToPrintDollarSigns()
   
   thread_to_print_dots.start()
   thread_to_print_dollar_signs.start()

   print( "\n Press the Enter key to stop the program. \n\n" )

   val any_string_from_keyboard  =  readLine()!!

   thread_to_print_dots.stop_this_thread()
   thread_to_print_dollar_signs.stop_this_thread()
}


